#include "strdef.h"
#include "rc.h"



LRESULT CALLBACK WinProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	static InternalData indata;
	RECT rc;

	switch (msg) {
	case WM_HSCROLL:
		return HScrollEventProc(hwnd, &indata, wp, lp);
	case WM_VSCROLL:
		return VScrollEventProc(hwnd, &indata, wp, lp);
	case WM_DESTROY:
		DeleteInternalData(&indata);
		RegisterButtonInfo(indata.hButton_Play, NULL, NULL, TRUE);
		PostQuitMessage(0);
		return 0;

	case WM_CREATE:
		//
		InitCommonControls();
		//[Ňo/Debuĝ
		_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF | _CRTDBG_LEAK_CHECK_DF);

		//͏
		SetTimer(hwnd, TIMER_ID_PLAY, 1000, NULL);
		indata.play.dwCallback = (DWORD_PTR)hwnd;
		//gbNo[/{^쐬
		CreateTrackbar(hwnd, &indata);
		CreateButton(hwnd, &indata);
/*
		//
		//eXg
		//

		dwResult = RegOpenKeyEx(HKEY_LOCAL_MACHINE, TEXT("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\MCI Extensions"), 0, KEY_QUERY_VALUE, &hKey);
		if (dwResult != ERROR_SUCCESS) {
			MessageBox(NULL, TEXT("WXgL[̃I[vɎs܂B"), NULL, MB_ICONWARNING);
			return -1;
		}

		for (;;) {
			dwData = sizeof(szData);
			dwValue = sizeof(szValue);

			dwResult = RegEnumValue(hKey, i, szValue, &dwValue, 0, 0, (LPBYTE)szData, &dwData);
			if (dwResult == ERROR_NO_MORE_ITEMS)
				break;

			OutputExeLog(L"ext:flag::%s:%s\n", szValue, szData);

			i++;
		}

		RegCloseKey(hKey);
		*/

		return 0;
	case WM_TIMER:
		return TimerEventProc(hwnd, &indata, wp, lp);
	case WM_SIZE:
		GetClientRect(hwnd, &rc);
		//|               V[No[                     |
		//|            O||||                  |
		//(ꕔ)
		MoveWindow(indata.hTrack_Play.hTrackbar, 0, rc.bottom - UI_HEIGHT * 2, LOWORD(lp), UI_HEIGHT, TRUE);
		MoveWindow(indata.hButton_Play.hButton, 0, rc.bottom - UI_HEIGHT, BUTTON_WIDE, UI_HEIGHT, TRUE);
		MoveWindow(indata.hButton_Sound.hButton, BUTTON_WIDE, rc.bottom - UI_HEIGHT, BUTTON_WIDE, UI_HEIGHT, TRUE);
		MoveWindow(indata.hTrack_Sound.hTrackbar, 0, rc.bottom - UI_HEIGHT * 2 - 200, BUTTON_WIDE + 5, 200, TRUE);

		return 0;
	case WM_NOTIFY:
		return  CustomDrawProc(hwnd, indata, wp, lp);
	case MM_MCINOTIFY:
		return MCINotifyEventProc(hwnd, &indata, wp, lp);
	case WM_COMMAND:
		return CmdEventProc(hwnd, &indata, wp, lp);
	}

	return DefWindowProcW(hwnd, msg, wp, lp);
}

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd)
{
	MSG msg;
	WNDCLASS wc;
	HWND hwnd;

	OutputExeLog(L"SoundPlayerJn܂...\n");

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WinProc;
	wc.cbClsExtra = wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hCursor = wc.hIcon = NULL;
	wc.hbrBackground = (HBRUSH)GetStockObject(BLACK_BRUSH);
	wc.lpszClassName = L"MainWindow";
	wc.lpszMenuName = L"SOUNDPLAYER";

	if (!RegisterClassW(&wc)) 
	{
		OutputExeLog(L"Ɏs܂\n");
		return -1;
	}
	


	hwnd = CreateWindowW(wc.lpszClassName, L"MainWindow", WS_OVERLAPPEDWINDOW | WS_VISIBLE,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);

	const long MAXFILELENGTH = MAX_PATH * 34;

	//
	//ŌĂяoƃoOȂ
	//
	//

	/*
	OPENFILENAMEW ofn;
	WCHAR fileName[MAXFILELENGTH] = { 0 };
	WCHAR strCustom[256] = L"Before files\0*.*\0\0";
	size_t iCnt = 0;
	size_t nPos;
	size_t Dirlen;

	ZeroMemory(&ofn, OPENFILENAME_SIZE_VERSION_400);


	ofn.lStructSize = OPENFILENAME_SIZE_VERSION_400;
	ofn.hwndOwner = hwnd;
	ofn.lpstrFilter = L"All Files(*.*)\0*.*\0\0";
	ofn.lpstrCustomFilter = strCustom;
	ofn.nMaxCustFilter = 256;
	ofn.nFilterIndex = 0;
	ofn.lpstrFile = fileName;
	ofn.nMaxFile = MAXFILELENGTH;
	ofn.Flags = OFN_FILEMUSTEXIST | OFN_HIDEREADONLY | OFN_ALLOWMULTISELECT | OFN_EXPLORER;
	ofn.lpstrTitle = L"J";


	GetOpenFileNameW(&ofn);
	*/

	if (hwnd == NULL) {
		assert(FALSE);
		return -1;
	}

	OutputExeLog(L"I\n");

	//GetMessage0-1̂ƂG[
	while (GetMessageW(&msg, NULL, 0, 0) > 0) 
	{	
		DispatchMessage(&msg);
	}

	//NX
	UnregisterClassW(wc.lpszClassName, hInstance);

	return (int)msg.wParam;

}
