#include "strdef.h"
#include "rc.h"

LRESULT CmdEventProc(HWND hwnd, InternalData *indata, WPARAM wp, LPARAM lp)
{
	WCHAR Temp[MAX_PATH * 2];

	switch (LOWORD(wp))
	{
	case IDM_EXIT:
		SendMessageW(hwnd, WM_DESTROY, 0, 0);
		break;
	case IDM_PLAY:
		break;
	case IDM_OPEN:
		//ĐĂA폜
		DeleteInternalData(indata);
		if (GetFileNames(hwnd, indata))
		{

			//MCȈ҂
			indata->hTrack_Play.Status |= SOUND_STATUS_WAIT_MCI;

			swprintf_s(Temp, L"%s\\%s", indata->ParentDir, indata->File[0]);
			InitSoundStruct(Temp, L"MPEGVideo", indata);
			StartPlaySound(indata);
			//{^̐ݒ
			SetWindowTextW(indata->hButton_Play.hButton, TEXT_BUTTON_PAUSE);

			//MCȈI
			indata->hTrack_Play.Status &= ~SOUND_STATUS_WAIT_MCI;

		}

		return 0;
	case BT_IDC_MCIBUTTON_PLAY:
		//݂̃Xe[^XlĐVXe[^X蓖Ă
		if (!(indata->hTrack_Play.Status & SOUND_STATUS_PLAY_PAUSED))
		{
			//Đ~߂
			indata->hTrack_Play.Status |= SOUND_STATUS_PLAY_PAUSED;
			mciSendCommandW(indata->open.wDeviceID, MCI_PAUSE, 0, 0);
			SetWindowTextW(indata->hButton_Play.hButton, TEXT_BUTTON_PLAY);
		}
		else 
		{
			//ĐĊJ
			if (indata->hTrack_Play.Status & SOUND_STATUS_DATA_EXSIST)
			{
				//tO|
				indata->hTrack_Play.Status &= ~SOUND_STATUS_PLAY_PAUSED;
				mciSendCommandW(indata->open.wDeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD_PTR)&indata->open);
				SetWindowTextW(indata->hButton_Play.hButton, TEXT_BUTTON_PAUSE);
			}
		}
		break;
	case BT_IDC_MCIBUTTON_SOUND:
		if (!indata->hTrack_Sound.Status)
		{
			ShowWindow(indata->hTrack_Sound.hTrackbar, SW_SHOW);
			SetTimer(hwnd, TIMER_ID_SOUND, 150, NULL);
			indata->hTrack_Sound.Status = SOUND_WINDOW_STATUS_SHOW;
		}
		else {
			ShowWindow(indata->hTrack_Sound.hTrackbar, SW_HIDE);
			KillTimer(hwnd, TIMER_ID_SOUND);
			indata->hTrack_Sound.Status = SOUND_WINDOW_STATUS_HIDE;
		}
		break;
	case IDM_VERSION_INFO:
		ShowVersionInfo(hwnd);
		break;
	}

	return 0;
}