#include "strdef.h"

//
//MCIgATEht@Cǂݍ
//lpFilePath...ǂݍ܂t@C
//lpstrDeviceType...̃t@C̃^Cv(̂Ƃmp3݂̂l)
//rettemp...쐬ꂽ\̂̏
//callflag...ǂݍݎsɁAcreate_temp_fileĂяoǂ
//
//return TRUE... / FALSE...s
//
int InitSoundStruct(LPCWSTR lpFilePath,LPCWSTR lpstrDeviceType,InternalData *retTemp,int callflag)
{
	MCIERROR result;
	WCHAR MsgBuf[1024];
	MCI_OPEN_PARMSW MPEGStruct = { 0 };

	if (!retTemp)
		return FALSE;

	MPEGStruct.lpstrDeviceType = lpstrDeviceType;
	MPEGStruct.lpstrElementName = lpFilePath;

	//Ƃ肠tO𗧂Ă
	retTemp->hTrack_Play.Status |= SOUND_STATUS_DATA_EXSIST;
	retTemp->hTrack_Play.Status |= SOUND_STATUS_ENABLE_PLAY;

	result = mciSendCommandW(
		0, MCI_OPEN, MCI_OPEN_TYPE | MCI_OPEN_ELEMENT,
		(DWORD_PTR)&MPEGStruct
	);
	if (result)
	{
		//s
		mciGetErrorStringW(result, MsgBuf, sizeof(MsgBuf));

		OutputExeLog(L"MCIError:%sFile;%s\n", MsgBuf, MPEGStruct.lpstrElementName);
		retTemp->open = MPEGStruct;

		//f[^݂͑Ȃ
		if (!callflag)
		{
			retTemp->hTrack_Play.Status &= ~SOUND_STATUS_DATA_EXSIST;
			retTemp->hTrack_Play.Status &= ~SOUND_STATUS_ENABLE_PLAY;
		}

		//callflagŔf
		return callflag == 1 ?
			create_temp_file(lpFilePath, lpstrDeviceType, retTemp) : FALSE;
	}

	OutputExeLog(L"t@C̓ǂݍ݂ɐ܂Bt@C:%s\n", lpFilePath);

	retTemp->open = MPEGStruct;

	return TRUE;
}

//
//syncheface(7bit)𕁒ʂ8bitɕϊ
//size[4]...synchface
//
//return ʂ8bit(4byte)
//
int unsynchsafe(char size[4])
{
	int ToRet = 0;

	if ((size[0] & 0x0F) || ((size[0] | size[1] | size[2] | size[3]) & 0x80))
	{
	}
	else {
		int Footer = size[0] & 0x10;
		ToRet = size[0] << 21;
		ToRet += size[1] << 14;
		ToRet += size[2] << 7;
		ToRet += size[3];
		ToRet += 10;
		if (Footer)
			ToRet += 10;
	}
	return ToRet;
}

//
//ID3^OƂAꂪȂԂmp3쐬
//lpFilePath...ID3^O邩Ȃt@CpX
//lpstrDeviceType...̃t@C̃^Cv(̂Ƃmp3݂̂l)
//rettemp...쐬ꂽ\̂̏
//
//return TRUE... / FALSE...s
//
int create_temp_file(LPCWSTR lpFilePath,LPCWSTR lpstrDeviceType,InternalData *retTemp)
{
	FILE *fp,*wfp;
	ID3V2HEADER head; //ID3vt@C邩ǂ
	DWORD size = 0;
//	char _size[32];

	_wfopen_s(&fp, lpFilePath, L"rb");

	if (!fp)
	{
		OutputExeLog(
			L"%s:t@C\"%s\"\n̓ǂݍ݂Ɏs܂B\n",
			__func__, lpFilePath
		);

		return 0;
	}

	ZeroMemory(&head, sizeof(head));
	fread(&head, sizeof(head), 1, fp);


	if (head.tag[0] != 'I' || 
		head.tag[1] != 'D' || 
		head.tag[2] != '3'
	)
	{
		OutputExeLog(L"ID3 header not found\n");
		goto err;
	}

	//
	//ID3Ȃmp3t@Co
	//
	//

	//syncface𕁒ʂ8bitɕϊ
	size = unsynchsafe(head.size);

	//header͂Ƃ肠ǂݔ΂
	long file_size;
	char *buffer;

	//t@CTCY擾
	//퓬Ɉړ
	fseek(fp, 0, SEEK_SET);

	if (fseek(fp, 0, SEEK_END) != 0) {
		/* G[ */
		goto err;
	}

	file_size = ftell(fp);
	if (file_size == -1) {
		/* G[ */
		goto err;
	}

	buffer = (char*)malloc(file_size - size);
	if (buffer == NULL) {
		/* G[ */
		goto err;
	}

	//mp3̐擪Ɉړ
	fseek(fp, size, SEEK_SET);
	
	//{̓ǂݍ
	fread(buffer, file_size - size, 1, fp);
	
	_wfopen_s(&wfp, TEMP_FILE_NAME, L"wb");
	if (!wfp)
		goto err;
	fwrite(buffer, file_size - size, 1, wfp);

	fclose(fp);
	free(buffer);
	fclose(wfp);

	//ēǂݍ݂݂
	return InitSoundStruct(
		TEMP_FILE_NAME,
		lpstrDeviceType,
		retTemp,
		FALSE);

err:
	fclose(fp);
	//tO|
	retTemp->hTrack_Play.Status &= ~SOUND_STATUS_DATA_EXSIST;
	retTemp->hTrack_Play.Status &= ~SOUND_STATUS_ENABLE_PLAY;
	return 0;
}

//
//Đ
//indata...ύXׂf[^\
//
//return TRUE
//
int StartPlaySound(InternalData *indata)
{
	MCI_STATUS_PARMS mciStatus;

	//ĐIƂɁAʒm󂯎
	mciSendCommandW(indata->open.wDeviceID, MCI_PLAY, MCI_NOTIFY, (DWORD_PTR)&indata->play);

	//
	//Ȃ̒擾
	//

	//Ƃ肠߂l'm'srcɂ
	mciStatus.dwItem = MCI_FORMAT_MILLISECONDS;
	mciSendCommandW(indata->open.wDeviceID, MCI_SET, MCI_SET_TIME_FORMAT, (DWORD_PTR)&mciStatus);

	mciStatus.dwItem = MCI_STATUS_LENGTH;
	mciSendCommandW(indata->open.wDeviceID, MCI_STATUS, MCI_STATUS_ITEM, (DWORD_PTR)&mciStatus);
	indata->maxSrc = (DWORD)mciStatus.dwReturn / 1000; //msrc->src

	//ʂ̐ݒ
	if (indata->Valume)
		SetSound(indata, indata->Valume);
	else
	{
		SetSound(indata, 75);
		indata->Valume = 75;
	}
	//gbNo[Ɋւݒ
	SendMessageW(indata->hTrack_Play.hTrackbar, TBM_SETRANGE, TRUE, MAKELPARAM(0, indata->maxSrc));
	//gbNo[̈ʒuݒ
	SendMessageW(indata->hTrack_Play.hTrackbar, TBM_SETPOS, TRUE, -1);

	return TRUE;
}

//
//쐬ꂽt@CpXf[^ׂč폜
//indata...폜ׂf[^\
//
//return ... TRUE
//
int DeleteInternalData_indata(InternalData *indata)
{
	int i;

	OutputExeLogA("f[^̍폜s܂B\n");

	//f[^ȂꍇȂ
	IF (!(indata->hTrack_Play.Status & SOUND_STATUS_DATA_EXSIST))
		return TRUE;

	//폜
	for (i = 0; i <= indata->MaxPlay; i++)
		free(indata->File[i]);

	free(indata->File);
	free(indata->ParentDir);

	return TRUE;
}

//
//쐬ꂽMCIf[^ׂč폜
//indata...폜ׂf[^\
//
//return ... TRUE
//
int DeleteInternalData_MCI(InternalData *indata)
{
	//f[^ȂꍇȂ
	if (!(indata->hTrack_Play.Status & SOUND_STATUS_DATA_EXSIST))
		return TRUE;

	//MCȈI
	mciSendCommandW(indata->open.wDeviceID, MCI_CLOSE, 0, 0);

	return TRUE;
}

//
//쐬ꂽt@CpXAMCIf[^Ƃf[^ׂč폜
//indata...폜ׂf[^\
//
//return ... TRUE
//
int DeleteInternalData(InternalData *indata)
{
	DeleteInternalData_indata(indata);
	DeleteInternalData_MCI(indata);

	deletetemp();

	//\̂̕
	indata->maxSrc = 0;
	indata->MaxPlay = 0;
	indata->hTrack_Play.Status = 0;

	return TRUE;
}

//
//ʂݒ肷
//
//SoundVolume...TEh̑傫
//reDraw...ݒ肵ʂɃgbNo[ݒ肷邩ǂ
//
BOOL SetSound(InternalData *indata,DWORD SoundVolume,BOOL reDraw)
{
	MCI_DGV_SETAUDIO_PARMS mdsp; //MCI_SETAUDIOR}h̏

	//MCI_SETAUDIOR}h̏̏
	mdsp.dwItem = MCI_DGV_SETAUDIO_VOLUME;
	mdsp.dwValue = SoundVolume;

	mciSendCommandW(indata->open.wDeviceID,
		MCI_SETAUDIO, MCI_DGV_SETAUDIO_VALUE | MCI_DGV_SETAUDIO_ITEM, (DWORD_PTR)&mdsp);

	if (reDraw)
	{
		SendMessageW(indata->hTrack_Sound.hTrackbar, TBM_SETPOS, TRUE, SoundVolume);
	}

	return 1;

}